#ifndef _KGR_PATCH_BSC1194533_H
#define _KGR_PATCH_BSC1194533_H

#if IS_ENABLED(CONFIG_NFC)

int kgr_patch_bsc1194533_init(void);
void kgr_patch_bsc1194533_cleanup(void);


struct nci_dev;
struct nfc_dev;
struct nfc_target;
struct sk_buff;

int kgrp_nci_close_device(struct nci_dev *ndev);
int kgrp_nci_dev_up(struct nfc_dev *nfc_dev);
int kgrp_nci_start_poll(struct nfc_dev *nfc_dev,
			  __u32 im_protocols, __u32 tm_protocols);
void kgrp_nci_stop_poll(struct nfc_dev *nfc_dev);
int kgrp_nci_activate_target(struct nfc_dev *nfc_dev,
			       struct nfc_target *target, __u32 protocol);
void kgrp_nci_deactivate_target(struct nfc_dev *nfc_dev,
				  struct nfc_target *target,
				  __u8 mode);
int kgrp_nci_dep_link_down(struct nfc_dev *nfc_dev);
void kgrp_nci_unregister_device(struct nci_dev *ndev);

int kgrp_nci_hci_send_cmd(struct nci_dev *ndev, u8 gate,
		     u8 cmd, const u8 *param, size_t param_len,
		     struct sk_buff **skb);
int kgrp_nci_hci_open_pipe(struct nci_dev *ndev, u8 pipe);

int kgrp_nci_hci_set_param(struct nci_dev *ndev, u8 gate, u8 idx,
		      const u8 *param, size_t param_len);
int kgrp_nci_hci_get_param(struct nci_dev *ndev, u8 gate, u8 idx,
		      struct sk_buff **skb);

int kgrp_nfc_dev_up(struct nfc_dev *dev);
int kgrp_nfc_register_device(struct nfc_dev *dev);
void kgrp_nfc_unregister_device(struct nfc_dev *dev);

#define KGR_PATCH_BSC1194533_FUNCS					\
	KGR_PATCH_OBJ(nci_close_device, kgrp_nci_close_device, "nci"),	\
	KGR_PATCH_OBJ(nci_dev_up, kgrp_nci_dev_up, "nci"),		\
	KGR_PATCH_OBJ(nci_start_poll, kgrp_nci_start_poll, "nci"),	\
	KGR_PATCH_OBJ(nci_stop_poll, kgrp_nci_stop_poll, "nci"),	\
	KGR_PATCH_OBJ(nci_activate_target, kgrp_nci_activate_target,	\
		      "nci"),						\
	KGR_PATCH_OBJ(nci_deactivate_target,				\
		      kgrp_nci_deactivate_target, "nci"),		\
	KGR_PATCH_OBJ(nci_dep_link_down, kgrp_nci_dep_link_down,	\
		      "nci"),						\
	KGR_PATCH_OBJ(nci_unregister_device,				\
		      kgrp_nci_unregister_device, "nci"),		\
	KGR_PATCH_OBJ(nci_hci_send_cmd, kgrp_nci_hci_send_cmd,		\
		      "nci"),						\
	KGR_PATCH_OBJ(nci_hci_open_pipe, kgrp_nci_hci_open_pipe,	\
		      "nci"),						\
	KGR_PATCH_OBJ(nci_hci_set_param, kgrp_nci_hci_set_param,	\
		      "nci"),						\
	KGR_PATCH_OBJ(nci_hci_get_param, kgrp_nci_hci_get_param,	\
		      "nci"),						\
	KGR_PATCH_OBJ(nfc_dev_up, kgrp_nfc_dev_up, "nfc"),		\
	KGR_PATCH_OBJ(nfc_register_device, kgrp_nfc_register_device,	\
		      "nfc"),						\
	KGR_PATCH_OBJ(nfc_unregister_device,				\
		      kgrp_nfc_unregister_device, "nfc"),		\

#else /* !IS_ENABLED(CONFIG_NFC) */

static inline int kgr_patch_bsc1194533_init(void) { return 0; }

static inline void kgr_patch_bsc1194533_cleanup(void) {}

#define KGR_PATCH_BSC1194533_FUNCS

#endif /* IS_ENABLED(CONFIG_NFC) */
#endif /* _KGR_PATCH_BSC1194533_H */
